#include "LifeControlWindow.h"

#include "MessageConstants.h"
#include "RenderPanel.h"

#include "LifeApplication.h"


static const BRect FRAME_MBAR(0,0,330,20);

LifeControlWindow::LifeControlWindow(BPoint p, const BMessenger& target)
		: BWindow
			( BRect(p, p)
			, "Controler"
			, B_TITLED_WINDOW_LOOK
			, B_NORMAL_WINDOW_FEEL
			, B_ASYNCHRONOUS_CONTROLS|B_WILL_ACCEPT_FIRST_CLICK)
//		, render_panel(NULL)
//		, color_panel(NULL)
{
	BMenuBar* v_bar = new BMenuBar(FRAME_MBAR, "life control mbar");
		BMenu* m;
		m=new BMenu("File");
			m->AddItem(new BMenuItem("New", new BMessage(MA_NEW), 'N'));
			m->AddItem(new BMenuItem("Open", new BMessage(MA_OPEN), 'O'));
			m->AddItem(new BMenuItem("Quit", new BMessage(MA_QUIT), 'Q'));
//			m->AddItem(new BMenuItem("Quit Anyway", new BMessage(MA_EXIT), 'E'));
			m->AddItem(new BMenuItem("About LifeHex...", new BMessage(MA_ABOUT)));
		m->SetTargetForItems(be_app);
		v_bar->AddItem(m);
		m=new BMenu("Play");
			m->AddItem(new BMenuItem("Go", new BMessage(MP_PLAY), 'P'));
			m->AddItem(new BMenuItem("Step", new BMessage(MP_STEP), ']'));
			m->AddItem(new BMenuItem("Randomize", new BMessage(MG_RANDOMIZE), 'R'));
			m->SetTargetForItems(target);
		v_bar->AddItem(m);
//		m=new BMenu("Screen");
//			m->AddItem(new BMenuItem("Window", new BMessage(MS_WINDOW)));
//			m->SetTargetForItems(target);
//			m->AddItem(new BMenuItem("Window Screen", new BMessage(MS_WINDOW_SCREEN)));
//			m->AddItem(new BMenuItem("Direct Window", new BMessage(MS_DIRECT_WINDOW)));
//		v_bar->AddItem(m);
	AddChild(v_bar);
	
	BView* render_panel = new RenderPanel(BPoint(0,20), target);
	AddChild(render_panel);
	
	BRect r=render_panel->Frame();
	ResizeTo(r.Width(), r.Height());
	float x,y;
	render_panel->GetPreferredSize(&x,&y);
	SetSizeLimits(20, x, 20, y);
	SetZoomLimits(x, y);
}

LifeControlWindow::~LifeControlWindow()
{
}



bool LifeControlWindow::QuitRequested()
{
//	if(msg && (msg->ReturnAddress()==this))
//	be_app->PostMessage(B_QUIT_REQUESTED);
	Minimize(true);
	return false;
}

/*
void LifeControlWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
	case MS_WINDOW_SCREEN:
	case MS_DIRECT_WINDOW:
		(new BAlert("","This feature is still under construction. (^^; ","OK"))->Go();
		break;
	default:
		BWindow::MessageReceived(msg);
	}
}

	
*/