#include "NameInputDialog.h"

static const BRect FRAME(0,0,200,100);
static const BRect FRAME_LABEL(10,5,190,30);
static const BRect FRAME_TEXT(20,30,180,60);
static const BRect FRAME_CANCEL(20,65,80,90);
static const BRect FRAME_OK(120,65,180,90);

enum{
	M_OK='OkOk',
	M_CANCEL = 'Cncl',
};

NameInputDialog::NameInputDialog
	( BPoint loc
	, BMessage* msg
	, BHandler* target
	, const char* label
	, const char* default_name)
	: BInvoker(msg, target)
	, BWindow
		( FRAME.OffsetByCopy(loc)
		, "Name Input"
		, B_DOCUMENT_WINDOW_LOOK
		, B_MODAL_SUBSET_WINDOW_FEEL
		, B_NOT_ZOOMABLE
			|B_NOT_MINIMIZABLE
			|B_NOT_V_RESIZABLE
			|B_ASYNCHRONOUS_CONTROLS
		)
{
	SetSizeLimits(150,500,60,110);
	BView* v= new BView(FRAME, "",B_FOLLOW_ALL_SIDES,0);
	v->SetViewColor(0xc0,0xc0,0xc0);
	
	BStringView* v_label = new BStringView
		( FRAME_LABEL
		, ""
		, ""
		, B_FOLLOW_LEFT_RIGHT
		);
	v->AddChild(v_label);
	if(label) v_label->SetText(label);

	v_name = new BTextControl
		( FRAME_TEXT
		, ""
		, ""
		, ""
		, new BMessage(M_OK)
		, B_FOLLOW_LEFT_RIGHT
		);
	v_name->SetDivider(0);
	v_name->TextView()->SetMaxBytes(63);
	if(default_name) v_name->SetText(default_name);
	v->AddChild(v_name);
	
	BButton* v_cancel = new BButton
		( FRAME_CANCEL
		, "cancel"
		, "Cancel"
		, new BMessage(B_QUIT_REQUESTED)
		);
	v->AddChild(v_cancel);
	
	BButton* v_ok = new BButton
		( FRAME_OK
		, "ok"
		, "OK"
		, new BMessage(M_OK)
		, B_FOLLOW_RIGHT
		);
	v->AddChild(v_ok);

	AddChild(v);
	v_name->MakeFocus(true);
}


void
NameInputDialog::MessageReceived(BMessage *msg)
{
	if(msg->what == M_OK)
	{
		BMessage m(Message());
		m.AddString("name", v_name->Text());
		Invoke(&m);
		PostMessage(B_QUIT_REQUESTED);
		return;
	}
	BWindow::MessageReceived(msg);
}