#ifndef RULE_LIST_WINDOW_H
#define RULE_LIST_WINDOW_H

#include "Prefix.h"

class RuleListView;
class RuleItem;

enum DocumentType
{
	NEW,
	NORMAL,
	READ_ONLY,
};


class RuleListWindow :public BWindow
{
friend class LifeApplication;
	static BLocker	window_list_lock;
	static BList	window_list;
	static bool		QuitAll();

//	
	DocumentType	type;
	entry_ref	file_ref;
	BFilePanel* save_panel;
	RuleListView*	v_list;
	BMenuBar*	v_bar;
	BButton*	v_new;
	BButton*	v_remove;
	
	BMenu*	m_file;
	BMenu*	m_edit;
	
	~RuleListWindow();
		
	bool QuitRequested();
	void MenusBeginning();

	void DialogRevert();
	void DialogSave();
	void DialogQuit();
	
	bool Save(entry_ref*);
	bool Load(entry_ref*);
	void SaveRequested(BMessage*);
	void LoadRequested(BMessage*);
	
public:
	RuleListWindow(BRect frame, const BMessenger&);
	void MessageReceived(BMessage*);
	void WindowActivated(bool);
};


#endif
