#include"HexGenerator.h"
#include"HexRule.h"

#define BPU		(sizeof(UNIT)*8)
#define SHIFT	(BPU-1)


HexGenerator::HexGenerator(hex_rule r)
{
	SetRule(r);
}

void HexGenerator::SetRule(hex_rule r)
{	
	uint32 a = ArithmeticRule(r);
	for(int i =0;i<32;i++)
	{
		arithmetic_rule_table[i]=(a&1)? (~0):0;
		a>>=1;
	}
}

void HexGenerator::Generate(UNIT* source_bits, UNIT *dest_bits, int num_units, int columns)
{
	const int rows = num_units/columns;
	const int total = columns*(rows-2);
	
	{
		register UNIT	*s((UNIT*)source_bits);
		register UNIT	*d((UNIT*)dest_bits);
		d+=columns;

		UNIT*	e(s + total);
		while(s<e)
		{
			register UNIT	L,TL,TR,R,BR,BL,C;
			TL	= *(s);
			TR	= (TL<<1)|(*(s+1)>>SHIFT);
			C	= *(s+=columns);
			R	= (C<<1)|(*(s+1)>>SHIFT);
			L	= (C>>1)|(*(s-1)<<SHIFT);
			BR	= *(s+=columns);
			BL	= (BR>>1)|(*(s-1)<<SHIFT);
			s-=columns*2;s++;
//C=*d;
			*(d++) = Result(L,TL,TR,R,BR,BL,C,arithmetic_rule_table);
		}
	}
	{
		register UNIT *d((UNIT*)dest_bits);
		register UNIT *s(d + columns);
		register UNIT *dd(s + total);
		register UNIT *ss(d + total);

		for(int i=0;i<columns;i++)
		{
			*(dd++) = *(s++);
			*(d++) = *(ss++);
		}
	}
}


