#ifndef LIFE_HEX_H
#define LIFE_HEX_H

#include "Prefix.h"

#include "HexRule.h"
class HexGenerator;


struct PixelMap;

class LifeHex
{
public:
	LifeHex();
	~LifeHex();
	void SetSize(int width, int height);
	void GetSize(int* width, int* height) const;
	void Randomize();
	void RandomizeLocal(int diameter);
	void EraseAll();
	void Dispose();
	void Generate();
	void SetRule(hex_rule rule);
	hex_rule Rule() const;
	void* GetBuffer() const;
	PixelMap	GetBufferInfo() const;
	bool InitCheck() const;

private:
	int		width, height;
	void*	life_buffer, *life_buffer1;
	area_id	area;
	size_t	life_buffer_size;
	hex_rule	rule;
	HexGenerator*	generator;
	bool	init_check;
};
#endif