#include "GenerationHandler.h"

#include "MessageConstants.h"
#include "LifeHex.h"
#include "LifeDaemon.h"

GenerationHandler::GenerationHandler(LifeDaemon* d)
	:BHandler("GenerationHandler")
	, daemon(d)
{
	life_hex = new LifeHex();
	life_hex->SetSize(512,512);
	daemon->life_hex=life_hex;
}
GenerationHandler::~GenerationHandler()
{
	daemon->life_hex=NULL;
	delete life_hex;
}

void
GenerationHandler::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
	case MG_RANDOMIZE:
			life_hex->Randomize();
		break;
	case MG_SET_SIZE:
		{
			int16 w, h;
			if(	(msg->FindInt16("width",&w)==B_OK) &&
				(msg->FindInt16("height",&h)==B_OK))
					life_hex->SetSize(w,h);
			if(life_hex->InitCheck())
				daemon->life_hex=life_hex;
			else
				daemon->life_hex=NULL;
		}
		break;
	case MG_SET_RULE:
		{
			int32 rule;
			if(msg->FindInt32("rule", &rule)==B_OK)
			{
				life_hex->SetRule((uint32)rule);
				life_hex->RandomizeLocal(31);
				if(CanFlash(rule));
			}
		}
		break;
	case MG_GET_RULE:
		{
			uint32 rule =life_hex->Rule();
			BMessage reply(MG_GET_RULE);
			reply.AddInt32("rule", rule);
			msg->SendReply(&reply);
		}
		break;
		default:
			BHandler::MessageReceived(msg);
		return;
	}
}