#ifndef RENDER_HANDLER_H
#define RENDER_HANDLER_H

#include "Prefix.h"

class Renderer;
class PixelMap;
class LifeDaemon;

class RenderHandler:public BHandler
{
public:
	enum MethodOption	
	{
		GRADATION,
		GENERATION,
		ROTATION,
		MONOCHROME,
	};
	
	enum	ScaleOption
	{
		SCALE_1=1,
		SCALE_2=2,
		SCALE_4=4,
		SCALE_8=8,
	};


public:
	void MessageReceived(BMessage*);
	RenderHandler(LifeDaemon*);
	~RenderHandler();
	
	Renderer*	GetRenderer();
	void	Reset();

	MethodOption	GetColorOption(){return render_option;}
	ScaleOption	GetScaleOption(){return scale_option;}
	void	SetOptions(MethodOption, ScaleOption);
	void	SetMethodOption(MethodOption c){SetOptions(c, scale_option);}
	void	SetScaleOption(ScaleOption s){SetOptions(render_option, s);}

private:
	void	ResetColorData();
	rgb_color	colors[256];
	MethodOption	render_option;
	ScaleOption		scale_option;
	Renderer*	renderer;
	LifeDaemon* daemon;
};


#endif


