#include "ScreenHandler.h"

#include "MessageConstants.h"
#include "LifeDaemon.h"
#include "LifeWindow.h"
//#include "LifeWindowScreen.h"

ScreenHandler::ScreenHandler(LifeDaemon* d)
	: BHandler("ScreenHandler")
	, daemon(d)
{
}

ScreenHandler::~ScreenHandler()
{
	SetScreen(NULL);
}

void
ScreenHandler::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case MS_WINDOW:
		{
			SetScreen(new LifeWindow(BMessenger(this)));
		}
		break;
		case MS_WINDOW_SCREEN:
		{
//			SetScreen(new LifeWindowScreen(B_8_BIT_1024x768, new BMessenger(this)));
		}
		break;
		default:
			BHandler::MessageReceived(msg);
		return;
	}
}


void
ScreenHandler::SetScreen(LifeScreen* s)
{
	LifeScreen* prev = daemon->screen;
	daemon->screen = NULL;
	if(prev) delete prev;

	if(s==NULL) return;
	if(s->InitCheck())
	{
		s->Show();
		daemon->screen = s;
	}
	else
		delete s;
}
