#ifndef LIFE_DAEMON_H
#define LIFE_DAEMON_H

#include "Prefix.h"


#include "Thread.h"

class Renderer;
class LifeScreen;
class LifeHex;


enum RateControlMode
{
	RELATIVE,
	ABSOLUTE_FRAME_RATE,
	ABSOLUTE_GENERATION_RATE,
};

class LifeDaemon:public Thread
{
public:
	LifeHex*	life_hex;
	LifeScreen*	screen;
	Renderer*	renderer;

	LifeDaemon();
	~LifeDaemon();
	
	bool	Lock();
	void	Unlock();
	bool	IsLocked();

	void	SetPeriod(int period);
	int		Period();
	void	SetSpeed(int percent);
	int		Speed();
	void	SetAvoidFlash(bool);
	bool	AvoidFlash();
	
	void	GetFrameRates(float* min, float*current, float*max);
//	void	SetFrameRates(float);
//	float	FrameRates();
//	void	SetRateControlMode(RateControlMode);

	void	Go();
	void	Step();

private:
	BLocker*locker;
	int		period;
	bool	exit;
	int		speed;
	bool	is_stepping;
	bool	avoid_flash;
	sem_id	step_sem;
	RateControlMode		rate_mode;
	
	static const unsigned	NUM_SAMPLES=10;
	bigtime_t	latency_sum;
	bigtime_t	latencies[NUM_SAMPLES];
	bigtime_t	interval_sum;
	bigtime_t	intervals[NUM_SAMPLES];

	status_t	Run();
};

#endif