#include "PixelMap.h"

PixelMap::PixelMap()
		: bits(NULL)
		, bits_offset(0)
		, bits_per_row(0)
		, width(0)
		, height(0)
		, pixel_size(0)
{}

PixelMap::PixelMap(const PixelMap* m)
{
	*this = *m;
}


PixelMap::PixelMap(
	void* bits, 
	int bits_offset, 
	int bits_per_row, 
	int width, 
	int height, 
	int pixel_size
	)
	: bits(bits)
	, bits_offset(bits_offset)
	, bits_per_row(bits_per_row)
	, width(width)
	, height(height)
	, pixel_size(pixel_size)
{}



int	PixelMap::BitsOffset(int x, int y) const
{
	return bits_offset + y*bits_per_row + x*pixel_size;
}

int PixelMap::GetAddress(uint8** address, int x, int y) const
{
	int offset = BitsOffset(x,y);
	*address = (uint8*)bits;
	*address += offset/8;
	return offset%8;
}

int PixelMap::GetAddress(uint16** address, int x, int y) const
{
	int offset = BitsOffset(x,y);
	*address = (uint16*)bits;
	*address += offset/16;
	return offset%16;
}

int PixelMap::GetAddress(uint32** address, int x, int y) const
{
	int offset = BitsOffset(x,y);
	*address = (uint32*)bits;
	*address += offset/32;
	return offset%32;
}


int PixelMap::GetAddress(uint64** address, int x, int y) const
{
	int offset = BitsOffset(x,y);
	*address = (uint64*)bits;
	*address += offset/64;
	return offset%64;
}

void PixelMap::DumpInfo() const
{
	printf("bits per row %ld\n", bits_per_row);
	printf("pixel size %ld\n", pixel_size);
	printf("width %ld\n", width);
	printf("height %ld\n", height);
}


/*
*/


