#include "Thread.h"

//========================================================

//

//========================================================



status_t
Thread::thread_mainthread(void *data)
{	
	Thread *t = (Thread*)data;
 	return t->Run();
}

Thread::Thread(const char *aName, long aPriority)
	: fThreadID(-1)
{
	// Create the actual Thread
	fThreadID = spawn_thread(thread_mainthread, aName, aPriority, this);
}

Thread::~Thread()
{
	long exitStatus;
	Kill();
	WaitForExit(&exitStatus);
}

status_t Thread::Run()
{
	return 0;
}

status_t
Thread::GetInfo(thread_info *info)
{
	return get_thread_info(fThreadID, info);
}


status_t	
Thread::Kill()
{
	return kill_thread(fThreadID);
}

status_t Thread::Resume()
{
	return resume_thread(fThreadID);
}

status_t Thread::Suspend()
{
	return suspend_thread(fThreadID);
}



status_t Thread::SetName(const char *newName)
{
	return rename_thread(fThreadID, newName);
}

status_t Thread::SetPriority(long newPriority)
{
	return set_thread_priority(fThreadID, newPriority);
}

status_t
Thread::WaitForExit(long *exitStatus)
{
	if(exitStatus==NULL)
	{
		long st;
		return wait_for_thread(fThreadID, &st);
	}
	else
	return wait_for_thread(fThreadID, exitStatus);
}


bool
Thread::IsCurrent()
{
	return find_thread(NULL) == fThreadID;
}
/*



status_t	

Thread::Snooze(bigtime_t microseconds)

{

	return snooze(microseconds);

}



extern thread_id	FindThread(const char *name); 

extern long			GetNthThreadInfo(team_id tmid, long n, thread_info *info);

*/



