#ifndef THREAD_H
#define THREAD_H

#include "Prefix.h"

class Thread
{
private:
	static status_t		thread_mainthread(void *data);

public:
			Thread(const char *aName, long aPriority = B_NORMAL_PRIORITY);
	virtual	~Thread();

	status_t	Kill();
	status_t	Resume();
	status_t	Suspend();

	status_t	GetInfo(thread_info *info);
	status_t	SetName(const char *name);
//	const char*	GetName();
	status_t	SetPriority(long priority);
//	long		GetPriority();
	status_t	WaitForExit (long *thread_return_value=NULL);
//	bigtime_t	GetSchedulingLatency();
	thread_id	ThreadID() {return fThreadID;};
	bool		IsCurrent();

protected:
	virtual 	status_t Run();
	thread_id	fThreadID;
};



#endif

