#ifndef BUFFERED_RENDERER_H
#define BUFFERED_RENDERER_H

#include "Prefix.h"

#include "Renderer.h"
#include "PixelMap.h"

class BufferedRenderer:public Renderer
{
public:
	BufferedRenderer(Renderer* rendererS, Renderer* rendererD, int pixel_size);
	~BufferedRenderer();

	void	Render(const PixelMap* source, PixelMap* dest);
protected:
	void	ColorModelChanged();
	void	InitBuffer(const PixelMap* source, const PixelMap* dest);
	int		pixel_size;
	PixelMap	buffer;
	Renderer*	rendererS;
	Renderer*	rendererD;
	
	area_id		area;
};

#endif