#include "HexRenderer.h"
#include "PixelMap.h"


HexRenderer::HexRenderer(int x, int y)
	:Renderer(x,y)
{}

void
HexRenderer::Render(const PixelMap* s_map, PixelMap* d_map)
{
	int w = min_c(s_map->width, d_map->width/scale_x);
	int h = min_c(s_map->height, d_map->height/scale_y);

	uint8 *s;
	uint8 *d;


	for(int r = 0;r< h; r++)
	{
		s_map->GetAddress(&s, 0, r);
		d_map->GetAddress(&d, 0, r*scale_y);
		if(r%2)
			render_odd(s, d, w, d_map->bits_per_row);
		else
			render_even(s, d, w, d_map->bits_per_row);
	}
}

