#include "RenderRow_1_4.h"


#include "BitIterator.h"

Data_1_4::Data_1_4()
{
	for(unsigned i=0;i<256;i++) data[i]= data_val(i);
	swap_data(B_INT32_TYPE, data, 256*sizeof(int32), B_SWAP_BENDIAN_TO_HOST);
}
/****************************************************************************************************/

RenderRow_1_4G::RenderRow_1_4G()
	: RenderRowFunction(1,4, 1,1)
{
	for(unsigned i=0;i<256;i++) data[i]&= 0x11111111;
}

void
RenderRow_1_4G::operator()(const UNIT* source, int bits_offset, void* dest, int n, int)
{
	BitIterator8<UNIT> it((const UNIT*)source, bits_offset);
	uint32* d((uint32*)(dest));
	n/=8;
	while(n-->0)
	{
		*d = (((*d)<<1)&0xeeeeeeee)|data[it.next()];
		d++;
	}
}

RenderRow_1_4R::RenderRow_1_4R()
	: RenderRowFunction(1,4, 1,1)
{
}

void
RenderRow_1_4R::operator()(const UNIT* source, int bits_offset, void* dest, int n, int)
{
	BitIterator8<UNIT> it((const UNIT*)source, bits_offset);
	uint32* d((uint32*)(dest));
	n/=8;
	register uint32 v;
	while(n-->0)
	{
		v = *d;
		v= ((v&0x77777777)+0x11111111)^(v&0x88888888);
		*(d++) = v & data[it.next()];
	}
}
RenderRow_1_4GR::RenderRow_1_4GR()
	: RenderRowFunction(1,4, 1,1)
{
}

void
RenderRow_1_4GR::operator()(const UNIT* source, int bits_offset, void* dest, int n, int)
{
	BitIterator8<UNIT> it((const UNIT*)source, bits_offset);
	uint32* d((uint32*)(dest));
	n/=8;
	register uint32 v;
	while(n-->0)
	{
		v = *d;
		v+= ~((v&(v>>1)&(v>>2)&(v>>3))|0xeeeeeeee);
		*(d++) = v & data[it.next()];
	}
}

RenderRow_1_4M::RenderRow_1_4M()
	: RenderRowFunction(1,4, 1,1)
{
}

void
RenderRow_1_4M::operator()(const UNIT* source, int bits_offset, void* dest, int n, int)
{
	BitIterator8<UNIT> it((const UNIT*)source, bits_offset);
	uint32* d((uint32*)(dest));
	n/=8;
	while(n-->0)
	{
		*(d++) = data[it.next()];
	}
}

/****************************************************************************************************/

uint32
Data_1_4::data_val(uint8 u)
{
	uint8 bit=1;
	uint32 m=0xf;
	uint32 r(0);
	for(int i=0;i<8;i++)
	{
		if(u&bit) r|= m<<(i*4);
		bit<<=1;
	}
	return r;
}
